// ==============================================================
//	This file is part of Glest (www.glest.org)
//
//	Copyright (C) 2001-2005 Martio Figueroa
//
//	You can redistribute this code and/or modify it under 
//	the terms of the GNU General Public License as published 
//	by the Free Software Foundation; either version 2 of the 
//	License, or (at your option) any later version
// ==============================================================

#ifndef _SHARED_UTIL_LOGGER_H_
#define _SHARED_UTIL_LOGGER_H_

#include <string>
#include <deque>

using std::string;
using std::deque;

namespace Glest{ namespace Game{

// =====================================================
//	class Logger  
//
/// Interface to write log files
// =====================================================

class Logger{
private:
	static const int logLineCount;

private:
	typedef deque<string> Strings;

private:
	string fileName;
	string sectionName;
	string state;
	Strings logLines;

private:
	Logger();

public:
	static Logger & getInstance();
	
	void setFile(const string &fileName){
	        string home;
		home = getenv("HOME_ETC") ? getenv("HOME_ETC") : getenv("HOME");
		this->fileName= home + "/.glest/" + fileName;
	}
	void setState(const string &state);

	void add(const string &str, bool renderScreen= false);
	void renderLoadingScreen();

	void clear();
};

}}//end namespace

#endif
